#!/bin/sh

MANAGED_FILE_LIST=$1
FILELIST=

[ "$MANAGED_FILE_LIST" = "" ] && exit 0
[ ! -f $MANAGED_FILE_LIST ] && exit 0

while read line; do
    FILELIST=`/bin/echo -e $line'\n'$FILELIST`
done <$MANAGED_FILE_LIST

HASHED_LOCATIONS="/bin /sbin /usr /usr/sbin /usr/libexec /usr/bin /usr/local/bin /usr/lib/pppd /usr/share/dbus-1 /etc /etc/ssl /etc/ssl/man /etc/ssl/certs /etc/profile.d /etc/ppp /etc/network /etc/network/if-up.d /etc/network/if-pre-up.d /etc/network/if-post-down.d /etc/network/if-down.d /etc/mosquitto /etc/libnl /etc/iproute2 /etc/init.d /etc/init.d/eichrecht /etc/dbus-1 /boot /root /home/eichrecht"

EXCLUDED_PATHS="/root/.ash_history /etc/passwd- /etc/shadow /etc/shadow- /etc/random-seed /etc/eichrecht/eichrecht.locked /etc/eichrecht/eichrecht.clean /home/eichrecht/logbook /home/eichrecht/eichrecht.hash /home/eichrecht/device.conf.json /home/eichrecht/evmd.page /home/eichrecht/private_key /home/eichrecht/public_key /home/eichrecht/device.conf.json.+ /home/eichrecht/type.conf.json.+ /home/eichrecht/sw_update.pub.+ /home/eichrecht/.ash_history /usr/bin/cmp /usr/bin/diff /usr/sbin/er_lock /usr/bin/opkg"

is_path_in_list()
{
    IFS=$' '
    for line in $FILELIST
    do
        if [ "$line" = "$1" ]
        then
            return 1
        fi
    done
    return 0
}

is_path_in_hashed_locations()
{
    IFS=$' '
    loc=`dirname $1`
    for line in $HASHED_LOCATIONS
    do
        if [ "$line" = "$loc" ]
        then
            return 1
        fi
    done
    return 0
}

is_path_excluded()
{
    IFS=$' '
    for line in $EXCLUDED_PATHS
    do
        if [ "$line" = "$1" ]
        then
            return 1
        fi
    done
    return 0
}

cleanup_artifacts()
{
    for p in $(find /boot /bin /sbin /usr /etc -type f -and -user root -and -group root)
    do
        is_path_in_list "$p"
        if [ $? -ne 1 ]
        then
            is_path_in_hashed_locations "$p"
            if [ $? -eq 1 ]
            then
                is_path_excluded "$p"
                if [ $? -eq 0 ]
                then
                    echo "removing artifact $p"
                    rm -f $p
                fi
            fi
        fi
    done
}

cleanup_artifacts
